var autoTrackBase = {
    customEvent: customEventTracker = function (str) {

        str = (typeof str !== 'string') ? "" : str;
        try{
            LP.Pub.Tracking.CustomerEventPublisher.publish('Custom_' + str);
        }
        catch(e){
            console.log(str);
        }
    },

    /*CALL create_eventTracker on the event you want to track with it's specific tracker URL*/
    clientEvent: clientEventTracker = function (src) {

        function createImgPx(param) {
            var pixelImg = document.createElement("IMG");
            /*optional attr*/
            pixelImg.alt = "lp-eventTracker";
            pixelImg.width = "1";
            pixelImg.height = "1";
            pixelImg.border = "0";
            pixelImg.src = srcHelper(param);
            /*End of optional attr*/
            pixelImg.onerror = function () {
                console.log("%c EVENT image failed at source : " + pixelImg.src, 'background: #222; color: #ff66ff');
            }
            pixelImg.onload = function () {
                console.log("%c EVENT image loaded from source : " + pixelImg.src, 'background: #222; color: #bada55');
                LP.Pub.Tracking.CustomerEventPublisher.publish('clientEventTracker_CALLED');
            }
        }

        /*If there is [timestamp] somewhere in URL,
        we must replace it by a random number*/

        function srcHelper(param) {

            if (param.indexOf("[timestamp]") >= 0) {
                param = timeStamp(param);
            }

            return param;
        }

        /*method Fnc that returns the modified version of the URL string after
        replacing "[timestamp]" by a random number.*/

        function timeStamp(param) {

            function requestRandomTS() {
                var axel = Math.random() + "";
                var a = axel * 10000000000000;
                return a;
            }

            param = param.replace("[timestamp]", requestRandomTS());
            return param;
        }

        createImgPx(src);
    },

    validateStringExpression: validateString = function (exp) {
        //replace all whitespaces
        exp = exp.replace(/\s/g, "_");

        //àâéèêëôöùûçï
        exp = exp.replace(/à/g, "a");
        exp = exp.replace(/â/g, "a");
        exp = exp.replace(/é/g, "e");
        exp = exp.replace(/è/g, "e");
        exp = exp.replace(/ê/g, "e");
        exp = exp.replace(/ë/g, "e");
        exp = exp.replace(/ô/g, "o");
        exp = exp.replace(/ö/g, "o");
        exp = exp.replace(/ù/g, "u");
        exp = exp.replace(/û/g, "u");
        exp = exp.replace(/ç/g, "c");
        exp = exp.replace(/ï/g, "i");

        //ÀÂÉÈÊËÔÖÙÛÇÏ
        exp = exp.replace(/À/g, "A");
        exp = exp.replace(/Â/g, "A");
        exp = exp.replace(/É/g, "E");
        exp = exp.replace(/È/g, "E");
        exp = exp.replace(/Ê/g, "E");
        exp = exp.replace(/Ë/g, "E");
        exp = exp.replace(/Ô/g, "O;");
        exp = exp.replace(/Ö/g, "O");
        exp = exp.replace(/Ù/g, "U");
        exp = exp.replace(/Û/g, "U");
        exp = exp.replace(/Ç/g, "C");
        exp = exp.replace(/Ï/g, "I");

        return exp;
    }
}
var autoTrackGallery = {
    typeGallery: trackGallery = function (obj) {
        var currentSlide = 0;
        var currentPosIsLastSlide = false;
        var maxSlides = obj.length - 1;

        obj.on('scrollEnd', function () {
            var pgx = obj.getCurrentPage().pageX

            currentPosIsLastSlide = (pgx == maxSlides && currentSlide == maxSlides);

            if (currentSlide !== pgx) {
                var tackerValue = obj.scroller.content.getElementsByTagName("li")[pgx].getAttribute("data-customValue");
                customEventTracker('Galerie_' + validateString(tackerValue));

                var thisClientValue = obj.scroller.content.getElementsByTagName("li")[pgx].getAttribute("data-clientTag");
                if (thisClientValue !== null) {
                    clientEventTracker(thisClientValue);
                }

                currentSlide = pgx;
            }

            if (pgx == maxSlides && currentSlide == maxSlides && currentPosIsLastSlide) {
                customEventTracker('Galery_requestingMoreImages');
            }
        });
    }
}

var autoTrack = { ...autoTrackBase, ...autoTrackGallery };